# labelo_p710bt: a print driver for the P-Touch P710BT Label Printer

The Brother P-Touch P710BT is a label printer that can print on various cassettes of label,
including adhesive labels and heat shrink. The printer then cuts the label with a blade.

The tape cassettes are readily available, both OEM and non-OEM.

This crate implements a basic print driver for this, letting you print out raster images.
It's a bit rough but at least somewhat usable.
My main motivation for me to publish this is to use it in my own project, but you are very welcome to try it
nonetheless — see the examples, especially the image example, for an understanding of how to use it.


## Features

- Identification of tape types and colours (but I didn't add all constants)
- Chain print (you can print multiple labels at once, and provided they are bigger than the minimum label size, you can cut each one individually without incurring the cut wastage for every label)
- Runnable examples: `p710bt` (prints a test pattern), `p710bt_exp_image` (accepts one or more images as arguments, then chain-prints them!)

## Limitations

- The library only contains numbers for 12mm and 24mm tapes
  - I only have the 24mm stock sample tape and some 12mm tapes to try. The print dimensions in the datasheet seem to be more conservative than they have to be...
- I haven't bothered to encode all the constants for all the types of tape. Sorry.
- Code is a bit rough, it was a quick hack to get the bare minimum for what I need working...
- There are possibly parts where I didn't follow the datasheet because I either didn't understand it or found that it seemed to mislead.
  E.g. for the print dimensions of each label, this library tells you a practical print height as well as the specified limit in the datasheet.



## Licence

Licensed under either of

- Apache Licence, Version 2.0 (LICENSE.Apache2 or http://www.apache.org/licenses/LICENSE-2.0)
- MIT Licence (LICENSE.MIT or http://opensource.org/licenses/MIT)

at your option.


## Contribution

Unless you explicitly state otherwise, any contribution intentionally submitted for inclusion in the work by you,
as defined in the Apache-2.0 licence, shall be dual licensed as above, without any additional terms or conditions.
